<template>
    <article class="box">
        <div class="columns is-desktop is-vcentered">
            <div :class="selecting || creating ? 'column is-12' : 'column is-8'">
            <h1 class="title is-5">Forma de Pagamento</h1>
            <template v-if="selecting">
                <PaymentMethodSelector
                    :paymentMethods="paymentMethods"
                    :selectedPaymentMethod="selectedPaymentMethod"
                    @click="paymentMethodSelected"
                />
            </template>
            <template v-else-if="creating">
                <PaymentMethodCreator
                    @cancel="creating = false"
                    @created="created"
                    @click="paymentMethodSelected"
                />
            </template>
            <template v-else>
                <template v-if="selectedPaymentMethod">
                    <div v-if="selectedPaymentMethod.isType === 'credit_card'">
                        <div class="v-align">
                            <b-icon class="barcode" size="is-large" icon="credit-card"></b-icon>
                            <span class="text">Cartão de Crédito - </span>
                                <b>{{ selectedPaymentMethod.card.issuer.name }} </b>
                                    final {{ selectedPaymentMethod.last_four }}
                        </div>
                    </div>
                    <div v-else-if="selectedPaymentMethod.isType === 'boleto'">
                        <div class="columns">
                            <div class="column">
                                <div class="v-align">
                                <b-icon class="barcode" size="is-large" icon="barcode"></b-icon>
                                <span class="text">(O Boleto será gerado quando finalizar o pedido) </span>
                            </div>
                            </div>
                        </div>
                        <div class="v-align">
                            <b-icon class="barcode" size="is-large" icon="print"></b-icon>
                            <span class="text">Imprima o boleto e <b>pague no banco</b> </span>
                        </div>
                    </div>
                    <div v-else>
                        <div class="v-align">
                            <b-icon class="barcode" size="is-large" icon="shopping-bag"></b-icon>
                            <span class="text">(Pagamento será realizado ao receber seu pedido) </span>
                        </div>
                    </div>
                    <br>
                </template>
                <div class="field is-grouped">
                    <div class="columns">
                        <div class="column">
                            <p class="control">
                                <a href="" class="button is-link" @click.prevent="selecting = true">Mudar Forma de Pagamento</a>
                            </p>
                        </div>
                        <div class="column">
                            <p class="control">
                                <a href="" class="button is-link" @click.prevent="creating = true">Nova Forma de Pagamento</a>
                            </p>
                        </div>
                    </div>
                </div>
            </template>
            <slot v-if="selecting === false && creating === false" name="installments" />
            </div>
            <div :class="selecting || creating ? '' : 'column is-4'">
                <div class="cvv">
                    <slot v-if="selecting === false && creating === false" name="cvv" />
                </div>
            </div>
        </div>
    </article>
</template>

<script>
    import PaymentMethodSelector from './PaymentMethodSelector';
    import PaymentMethodCreator from './PaymentMethodCreator';
    import { mapActions, mapGetters } from 'vuex';

    export default {

        data() {
            return {
                selecting: false,
                creating: false,
                localPaymentMethods: this.paymentMethods,
                selectedPaymentMethod: null,
            }
        },

        components: {
            PaymentMethodSelector,
            PaymentMethodCreator
        },

        watch: {
            selectedPaymentMethod(paymentMethod) {
                if (typeof paymentMethod !== 'undefined') {
                    this.$emit('input', paymentMethod.id)
                }
            }
        },

        computed: {
            defaultPaymentMethod() {
                return this.localPaymentMethods.find(pm => pm.default === true)
            },
        },

        methods: {

            ...mapActions({
                changePaymentDefault: 'cart/changePaymentDefault',
                setPaymentMethod: 'cart/setPaymentMethod'
            }),

            paymentMethodSelected(paymentMethod){
                this.switchPaymentMethod(paymentMethod)
                this.setPaymentMethod(paymentMethod)
                this.changePaymentDefault(paymentMethod.id)
                this.selecting = false
            },
            switchPaymentMethod(paymentMethod){
                this.selectedPaymentMethod = paymentMethod
                this.$emit('change', paymentMethod)
            },

            created(paymentMethod) {
                this.$emit('created', paymentMethod)

                this.localPaymentMethods.push(paymentMethod)

                this.creating = false

                this.switchPaymentMethod(paymentMethod)
            },
        },

        created() {
            if (this.paymentMethods){
                this.switchPaymentMethod(this.defaultPaymentMethod)
                this.creating = false
            }
        },

        props: ['paymentMethods']
        // {
        //     paymentMethods: {
        //         type: Array,
        //         required: true
        //     },
        // }
    }
</script>

<style scoped>
    .cvv {
        align-items: center;
        justify-items: center;
        vertical-align: middle;
    }

    .v-align {
        line-height: 30px;
        /* padding: 10px 0; */
        display: table-cell;
        vertical-align: middle;
    }

    .v-align > .barcode {
        /* padding-top: 20px; */
        vertical-align: middle;
    }

    .v-align > .text {
        font-size: .85em;
    }
</style>
